#include <string.h>
#include "fonctions.h"

long findStartIntro(const char *fileName){
	FILE *fichier;
	if ((fichier = fopen(fileName, "rb")) == NULL) return -2;
	int tab[4];
	for(int i=0;i<4;i++)
		tab[i] = fgetc(fichier);
	fclose(fichier);
	
	if(tab[0] != 0x2E || tab[1]!=0x00 || tab[2]!=0x00){
		unsigned long soffs;
		soffs=(tab[2]<<16)|(tab[1]<<8)|tab[0];
		soffs=8+(soffs&0x00FFFFFF)*4;
		return soffs;
	}
	else return -1;
}


long resizeRom(const char *fileName, const char *fileSave, long startIntro){
	FILE *fichier1, *fichier2;
	if ((fichier1 = fopen(fileName, "rb"))==NULL)return -1;
	int limite;
	int j;
	int k=0;

	//recherche du nb de char a copier
	j = fgetc(fichier1);
	while(!feof(fichier1) && (startIntro<0 || k<startIntro)){
		k++;
		if (j!=0x00 && j!=0xFF) limite = k;
		j = fgetc(fichier1);
	}

	if ((fichier2 = fopen(fileSave, "wb"))==NULL)return -2;

	//ecriture de l'adresse de dpard si ncessaire
	k=0;
	if (startIntro > 0){
		fputc(0x2E, fichier2);
		fputc(0x00, fichier2);
		fputc(0x00, fichier2);
		k=3;
		fseek(fichier1, 3, SEEK_SET);
	}
	else fseek(fichier1, 0, SEEK_SET);
	

	//copie du fichier
	for(k;k<limite;k++)
		fputc(fgetc(fichier1), fichier2);

	fclose(fichier1);
	fclose(fichier2);

	return limite;
}
