/*
Made by Replouf66

easy to use:

resizeRom [option] <source file> <destination file>

option are:

-r  for remove intro or trainer if exist

*/

#include <string.h>
#include "fonctions.h"

int main(int argc, char* argv[]){
	long startIntro=-1;
	bool removeIntro=false;
	char *fileName;
	char *fileSave;
	if (argc<3){
		printf("\n<prog> [-options] <filename> <filesave>\nOptions are:\n\t-r\tfor remove intro or trainer if exist.\n\n");
		return -1;
	}
	else if (argc==3){
		fileName = argv[1];
		fileSave = argv[2];
	}
	else if (argc==4){
		if (strcmp(argv[1], "-r")==0) removeIntro=true;
		else{
			printf("\n<prog> [-options] <filename> <filesave>\nOptions are:\n\t-r\tfor remove intro or trainer if exist.\n\n");
			return -1;
		}
		fileName = argv[2];
		fileSave = argv[3];
	}

	if(removeIntro){
		startIntro = findStartIntro(fileName);
	}

	long i = resizeRom(fileName, fileSave, startIntro);
	if (i<0) printf("erreur");
	else printf("New size: %.2f\n",(double)i/131072);

	return 0;
}
